/* eslint-disable import/no-unresolved, no-console */
'use strict' // eslint-disable-line

process.env.NODE_ENV = 'production'

process.on('unhandledRejection', (err) => {
  throw err
})

// 确保环境变量已经被读取.
require('config-ivan')()

const chalk = require('chalk')
const fs = require('fs-extra')
const webpack = require('webpack')

const config = require('./webpack.config.build')
const paths = require('./utils/paths')

fs.emptyDirSync(paths.appBuild)
// 将Public中的文件和文件夹拷贝到打包文件夹中
fs.copySync(paths.appPublic, paths.appBuild, {
  dereference: true,
  filter: file => file !== paths.appHtml,
})
// 打包
webpack(config, (err, stats) => {
  if (err) {
    console.error(chalk.red('编译失败.\n', err.stack || err))
    if (err.details) {
      console.error(chalk.red(err.details))
    }
    process.exit(1)
  }

  console.log(stats.toString({
    colors: true, // 在控制台展示颜色
  }))

  const info = stats.toJson()

  if (stats.hasErrors()) {
    console.error(chalk.red(info.errors))
    process.exit(1)
  }

  if (stats.hasWarnings()) {
    console.warn(chalk.yellow(info.warnings))
  }

  console.log(chalk.cyan('编译完成.\n'))
})
