import React from 'react'
import { connect } from 'react-redux'
import PropTypes from 'prop-types'

import App from '../../components/app/app'
import { getData } from '../../actions/app'

function mapStatetoProps(state) {
  return {
    text: state.app.helloWorld,
  }
}

class AppContainer extends React.Component {
  static propTypes = {
    dispatch: PropTypes.func.isRequired,
  }

  handleClick = (e) => {
    e.stopPropagation()
    this.props.dispatch(getData('React Hello!'))
  }

  render() {
    return (<App {...this.props} handleClick={this.handleClick} />)
  }
}

export default connect(mapStatetoProps)(AppContainer)
