'use strict' // eslint-disable-line

const chalk = require('chalk')
const detect = require('detect-port-alt')

function choosePort(host, defaultPort) {
  // 检查端口是否被占用
  return detect(defaultPort, host).then(
    port =>
      new Promise((resolve) => {
        if (port === defaultPort) {
          return resolve(port)
        }
        throw new Error(`${chalk.red(`${port} was occupied, please run on another port`)}`)
      }),
    (err) => {
      throw new Error(`${chalk.red(`Could not find an open port at ${chalk.bold(host)}.`)
      }\n${
        `Network error message: ${err.message}` || err
      }\n`)
    },
  )
}

module.exports = choosePort
