'use strict' // eslint-disable-line

const config = require('./webpack.config.dev')
const paths = require('./utils/paths')
const ignoredFiles = require('./utils/ignoredFiles')

module.exports = {
  compress: true,
  clientLogLevel: 'none',
  contentBase: paths.appPublic,
  watchContentBase: true,
  hot: true,
  publicPath: config.output.publicPath,
  // quiet: true,
  watchOptions: {
    ignored: ignoredFiles(paths.appSrc),
  },
  https: process.env.HTTPS === 'true',
  host: process.env.HOST || 'localhost',
  overlay: false,
  historyApiFallback: {
    // Paths with dots should still use the history fallback.
    // See https://github.com/facebookincubator/create-react-app/issues/387.
    disableDotRule: true,
  },
  // proxy属性参考https://doc.webpack-china.org/configuration/dev-server/#devserver-proxy
  // proxy设置参考https://github.com/chimurai/http-proxy-middleware#example
  // 从项目package.json文件proxy属性上获取相关配置
  proxy: paths.appPackageJson.proxy || {},
}
